// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_contracts_with_service_connection_grant.sql

package queries

import (
	"context"

	"github.com/gofrs/uuid"
	"github.com/jackc/pgx/v5/pgtype"
)

const listContractsForPeerWithServiceConnectionGrant = `-- name: ListContractsForPeerWithServiceConnectionGrant :many

SELECT
    c.iv AS content_iv,
    c.hash as content_hash,
    c.hash_algorithm as content_hash_algorithm,
    c.group_id as content_group_id,
    c.valid_not_before as content_valid_not_before,
    c.valid_not_after as content_valid_not_after,
    c.created_at as content_created_at
FROM contracts.content as c
     INNER JOIN contracts.grants_service_connection as gc
        ON gc.content_hash = c.hash
WHERE
    (
        gc.service_peer_id = $2::text OR
        gc.outway_peer_id = $2::text
    ) AND
    (
                $3::text = ''
            OR
                ($4::text = 'asc' AND c.iv > $3::uuid)
            OR
                ($4::text = 'desc' AND c.iv < $3::uuid)
        )
ORDER BY
CASE
    WHEN $4::text = 'asc' THEN c.iv  END ASC,
CASE
    WHEN $4::text = 'desc' THEN c.iv END DESC
LIMIT $1
`

type ListContractsForPeerWithServiceConnectionGrantParams struct {
	Limit             int32
	PeerID            string
	PaginationStartID string
	OrderDirection    string
}

type ListContractsForPeerWithServiceConnectionGrantRow struct {
	ContentIv             uuid.UUID
	ContentHash           string
	ContentHashAlgorithm  ContractsContentHashAlgorithm
	ContentGroupID        string
	ContentValidNotBefore pgtype.Timestamptz
	ContentValidNotAfter  pgtype.Timestamptz
	ContentCreatedAt      pgtype.Timestamptz
}

// Copyright © VNG Realisatie 2022
// Licensed under the EUPL
// NOTE: unable to use ASC/DESC dynamically so we use a switch case
func (q *Queries) ListContractsForPeerWithServiceConnectionGrant(ctx context.Context, arg *ListContractsForPeerWithServiceConnectionGrantParams) ([]*ListContractsForPeerWithServiceConnectionGrantRow, error) {
	rows, err := q.db.Query(ctx, listContractsForPeerWithServiceConnectionGrant,
		arg.Limit,
		arg.PeerID,
		arg.PaginationStartID,
		arg.OrderDirection,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListContractsForPeerWithServiceConnectionGrantRow{}
	for rows.Next() {
		var i ListContractsForPeerWithServiceConnectionGrantRow
		if err := rows.Scan(
			&i.ContentIv,
			&i.ContentHash,
			&i.ContentHashAlgorithm,
			&i.ContentGroupID,
			&i.ContentValidNotBefore,
			&i.ContentValidNotAfter,
			&i.ContentCreatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
